#import "QCPatch.h"
#import "QCBooleanPort.h"
#import "QCNumberPort.h"

#ifndef MAC_OS_X_VERSION_MIN_REQUIRED
#define MAC_OS_X_VERSION_MIN_REQUIRED MAC_OS_X_VERSION_10_2
#endif

#import "WiiRemote.h"
#import "WiiRemoteDiscovery.h"

@interface WiiMoteControlPatch : QCPatch
{
    QCBooleanPort	*outputWiiMoteConnected;
	QCBooleanPort	*outputAButton;
	QCBooleanPort	*outputBButton;
	QCBooleanPort	*output1Button;
	QCBooleanPort	*output2Button;
	QCBooleanPort	*outputPlusButton;
	QCBooleanPort	*outputMinusButton;
	QCBooleanPort	*outputHomeButton;
	QCBooleanPort	*outputUpButton;
	QCBooleanPort	*outputDownButton;
	QCBooleanPort	*outputLeftButton;
	QCBooleanPort	*outputRightButton;
	
	QCNumberPort	*outputXAccel;
	QCNumberPort	*outputYAccel;
	QCNumberPort	*outputZAccel;
	
	// Tilt requires math on the accel axes
	QCNumberPort	*outputPitch;
	QCNumberPort	*outputRoll;

	// IR stuff
	QCNumberPort	*outputIRX;
	QCNumberPort	*outputIRY;
	
	// Nunchuk stuff
	QCBooleanPort	*outputCButton;
	QCBooleanPort	*outputZButton;
	QCNumberPort	*outputXTilt;
	QCNumberPort	*outputYTilt;
	QCNumberPort	*outputNunchukXAccel;
	QCNumberPort	*outputNunchukYAccel;
	QCNumberPort	*outputNunchukZAccel;
	QCNumberPort	*outputNunchukPitch;
	QCNumberPort	*outputNunchukRoll;
	

	// classic controll stuff will go here when I get it.  Will it make this patch too monstrous?

@private
	NSLock				*remoteLock;	// many of our delegate functions are signal- and thread-unsafe.  This is our safety net.
	WiiRemoteDiscovery	*discover;
	WiiRemote			*remote;
	double				pitch, roll;
	double				nunchukPitch, nunchukRoll;
	unsigned long		discoverTime;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

+ (Class)inspectorClassWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(id)fp8;
- (void)cleanup:(id)fp8;

- (void)enable:(id)fp8;
- (void)disable:(id)fp8;

- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20;

// WiiMote delegate interface methods
- (void) WiiRemoteDiscovered:(WiiRemote*)wiimote;
- (void) WiiRemoteDiscoveryError:(int)code;
- (void) wiiRemoteDisconnected:(IOBluetoothDevice*)device;

@end